<div [solidifySpinner]="isLoading"
     class="wrapper"
>
  @if (isReadyToBeDisplayed) {
    @if (isTextFile) {
      <div class="header">
        @if ((isEditObs | async | isFalse) && (canEditObs | async) !== depositEditModeEnum.none) {
          <p>{{labelTranslateEnum.hereYouCanDescribeHowToUseYourDeposit | translate}}</p>
          <p>{{labelTranslateEnum.theCurrentReadmeFileIsEditable | translate}}</p>
          <p>{{labelTranslateEnum.youCanModifyItOrSendAFile | translate}}</p>
          <div class="buttons-wrapper">
            <ng-container *ngTemplateOutlet="editButtons"></ng-container>
          </div>
        } @else if (isEditObs | async | isFalse) {
          <div class="buttons-wrapper">
            <ng-container *ngTemplateOutlet="downloadButtons"></ng-container>
          </div>
        }
      </div>
      <dlcm-deposit-readme-form #formPresentational
                                [model]="model"
                                [editAvailable]="(canEditObs | async) !== depositEditModeEnum.none"
                                [readonly]="isEditObs | async | isFalse"
                                [solidifySpinner]="isLoading$()"
                                (submitChange)="update($event)"
                                (editChange)="edit()"
      ></dlcm-deposit-readme-form>
    } @else {
      <div class="header">
        @if ((canEditObs | async) !== depositEditModeEnum.none) {
          <p>{{labelTranslateEnum.hereYouCanDescribeHowToUseYourDeposit | translate}}</p>
          <p>{{labelTranslateEnum.theCurrentReadmeFileIsNotEditable | translate}}</p>
          <p>{{labelTranslateEnum.youCanSendANewVersionOfTheFileOrSwitchToAnEditableFile | translate}}</p>
          <div class="buttons-wrapper">
            <ng-container *ngTemplateOutlet="editButtons"></ng-container>
          </div>
        } @else {
          <div class="buttons-wrapper">
            <ng-container *ngTemplateOutlet="downloadButtons"></ng-container>
          </div>
        }
      </div>

      @if (visualizer | isNotNullNorUndefined) {
        <solidify-file-visualizer [fileToVisualize]="fileInput"
                                  [zoomEnable]="true"
                                  [fileDownloadUrl]="downloadUrl"
                                  [isInDialog]="false"
        ></solidify-file-visualizer>
      } @else {
        @if (visualizerErrorMessage | isNotNullNorUndefinedNorWhiteString) {
          {{visualizerErrorMessage | translate}}
        } @else {
          {{labelTranslateEnum.unableToPreviewReadme | translate}}
        }
      }
    }
  }
</div>


<ng-template #editButtons>
  <button solidifyFileDropZone
          (fileDropped)="uploadFile($event)"
          solidifyAlternativeButton
          (click)="uploadFile()"
  >
    <solidify-icon [iconName]="iconNameEnum.uploadFile"></solidify-icon>
    {{labelTranslateEnum.uploadAReadmeFile | translate}}
  </button>
  @if (readmeDataFile | isNotNullNorUndefined) {
    <ng-container *ngTemplateOutlet="downloadButtons"></ng-container>
    <button mat-button
            color="warn"
            (click)="isTextFile ? delete() : switchToNewFile()"
    >
      <solidify-icon [iconName]="isTextFile ? iconNameEnum.delete : iconNameEnum.reset"></solidify-icon>
      {{(isTextFile ? labelTranslateEnum.delete : labelTranslateEnum.switchToANewEditableFile)| translate}}
    </button>
  }
</ng-template>

<ng-template #downloadButtons>
  <button mat-button
          color="primary"
          (click)="downloadFile()"
  >
    <solidify-icon [iconName]="iconNameEnum.download"></solidify-icon>
    {{labelTranslateEnum.download | translate}}
  </button>
</ng-template>